package com.steerinfo.meterwork.meterworkshiftreportgroup.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.meterworkshiftreport.model.MeterWorkShiftReport;
import com.steerinfo.meterwork.meterworkshiftreportgroup.model.MeterWorkShiftReportGroup;
import com.steerinfo.meterwork.meterworkshiftreportgroup.service.IMeterWorkShiftReportGroupService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkShiftReportGroup RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-12-16 03:10
 * 类描述
 * 修订历史：
 * 日期：2022-12-16
 * 作者：generator
 * 参考：
 * 描述：MeterWorkShiftReportGroup RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkshiftreportgroups")
public class MeterWorkShiftReportGroupController extends BaseRESTfulController {

    @Autowired
    IMeterWorkShiftReportGroupService meterWorkShiftReportGroupService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkshiftreportgroup:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkShiftReportGroup> list = meterWorkShiftReportGroupService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkshiftreportgroup:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkShiftReportGroup> list = meterWorkShiftReportGroupService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkShiftReportGroup对象创建")
    @ApiImplicitParam(name = "meterWorkShiftReportGroup", value = "详细实体meterWorkShiftReportGroup", required = true, dataType = "MeterWorkShiftReportGroup")
    //@RequiresPermissions("meterworkshiftreportgroup:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkShiftReportGroup model){
        MeterWorkShiftReportGroup meterWorkShiftReportGroup = meterWorkShiftReportGroupService.add(model);
        return success(meterWorkShiftReportGroup);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkshiftreportgroup:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkShiftReportGroup meterWorkShiftReportGroup = meterWorkShiftReportGroupService.getById(id);
        return success(meterWorkShiftReportGroup);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkShiftReportGroup信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkShiftReportGroup", value = "详细实体meterWorkShiftReportGroup", required = true, dataType = "MeterWorkShiftReportGroup")
    })
    //@RequiresPermissions("meterworkshiftreportgroup:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkShiftReportGroup model){
        model.setId(id);
        MeterWorkShiftReportGroup meterWorkShiftReportGroup = meterWorkShiftReportGroupService.modify(model);
        return success(meterWorkShiftReportGroup);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkshiftreportgroup:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkShiftReportGroupService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="根据日期查询", notes="只能查询一条数据")
    @PostMapping(value = "/likeByCreateTime")
    public RESTfulResult likeByCreateTime(@RequestBody HashMap parmas){
        PageList<MeterWorkShiftReportGroup> list = meterWorkShiftReportGroupService.likeByCreateTime(parmas);
        return success(list);
    }

    @ApiOperation(value="修改数据配置", notes="修改数据配置")
    @PostMapping(value = "/updateModel")
    public RESTfulResult updateModel(@RequestBody MeterWorkShiftReportGroup model){
        MeterWorkShiftReportGroup meterWorkShiftReport = meterWorkShiftReportGroupService.updateModel(model);
        return success(meterWorkShiftReport);
    }

    @ApiOperation(value="新增数据配置", notes="新增数据配置")
    @PostMapping(value = "/addModel")
    public RESTfulResult addModel(@RequestBody MeterWorkShiftReportGroup model){
        MeterWorkShiftReportGroup meterWorkShiftReport = meterWorkShiftReportGroupService.addModel(model);
        return success(meterWorkShiftReport);
    }
}
